Блог пользователя Vladosiya

Автор Vladosiya, история, 5 месяцев назад, По-русски

1907A - Ладья

Идея: pashka

Разбор
Решение

1907B - YetnotherrokenKeoard

Идея: pashka, MikeMirzayanov

Разбор
Решение

1907C - Удаление некрасивых пар

Идея: Vladosiya

Разбор
Решение

1907D - Прыжки по отрезкам

Идея: MikeMirzayanov, Vladosiya

Разбор
Решение

1907E - Хорошие тройки

Идея: pashka

Разбор
Решение

1907F - Сдвиг и разворот

Идея: pashka

Разбор
Решение

1907G - Освещение

Идея: pashka

Разбор
Решение
Разбор задач Codeforces Round 913 (Div. 3)
  • Проголосовать: нравится
  • +27
  • Проголосовать: не нравится

»
5 месяцев назад, # |
Rev. 2   Проголосовать: нравится +27 Проголосовать: не нравится

It would be better if you added formatting for the solution to Problem F.

UPD: Thanks

»
5 месяцев назад, # |
Rev. 4   Проголосовать: нравится +22 Проголосовать: не нравится

In E, we can also notice that the answer to each digit x(0-9) is simply ((x+1)*(x+2))/2.

Explanation 1: Let, x be split as x=a+b+c. If a=x, b+c=0; this will generate one combination->(x,0,0). If a=x-1, b+c=1; this will generate two combinations->(x-1,0,1) and (x-1,1,0).Similarly you can notice that the total combinations for digit x= 1+2+3+..+x+x+1= ((x+1)*(x+2))/2. So, no need to use the loops to calculate this.

Explanation 2(Suggested by my brother): The combinatorics formula to distribute x as a sum of k non-negative numbers is C(n+k-1,k-1) which here transforms to C(x+3-1,3-1)=C(x+2,2)=((x+1)*(x+2))/2.

Or, you could have just figured this out by looking at the test cases.

»
5 месяцев назад, # |
  Проголосовать: нравится +5 Проголосовать: не нравится

Video Editorial For Problems A,B,C,D,E,F,G._

  • »
    »
    5 месяцев назад, # ^ |
      Проголосовать: нравится +3 Проголосовать: не нравится

    After this video, can you speak English or have subtitles in English for your video so that all coders around the world can understand it?

  • »
    »
    5 месяцев назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    Greeting sir/bhiya

    I am trying this question from tomorrow smjh nahi aarha kaha galti kr raha hu , if you could point it would be great help .

    Link of submission .

    Thankyou

    • »
      »
      »
      5 месяцев назад, # ^ |
        Проголосовать: нравится +1 Проголосовать: не нравится

      The way you are moving from one node to another while applying topological sort is wrong and also you are code is bit messy while solving around cycle of the graph. You can look at my code to understand it better. My code

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

wasn't able to participate in this contest, but the problems were very good, I think. although G does feel like it reduces down to just applying a standard graph algorithm, no?

»
5 месяцев назад, # |
  Проголосовать: нравится +12 Проголосовать: не нравится

Video solution for Chinese:

BiliBili

»
5 месяцев назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

Video Explanations

Problem A 1907A Rook

Problem B 1907B YetnotherrokenKeoard

Problem C 1907C Removal of Unattractive Pairs

Problem D 1907D Jumping Through Segments

Problem E 1907E Good Triples

»
5 месяцев назад, # |
Rev. 2   Проголосовать: нравится +29 Проголосовать: не нравится
My DP solution for E - Good Triples
  • »
    »
    5 месяцев назад, # ^ |
      Проголосовать: нравится +4 Проголосовать: не нравится

    Can you explain the transition states in this DP.

  • »
    »
    5 месяцев назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    Wow! It so a beautiful DP

  • »
    »
    5 месяцев назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    If anyone gets this solution , kindly do explain.

    • »
      »
      »
      5 месяцев назад, # ^ |
      Rev. 3   Проголосовать: нравится 0 Проголосовать: не нравится

      From the editorial, we know
          dp[i] = dp[i / 10] * dp[i % 10],
          dp[i - 1] = dp[(i - 1) / 10] * dp[(i - 1) % 10]
      if i >= 10 and i % 10 == 0 then
          dp[i] = dp[i / 10] * dp[0] = dp[i / 10]
      if i >= 10 and i % 10 > 0, then
          dp[(i - 1) / 10] = dp[i / 10],
          dp[(i - 1) % 10] = dp[i % 10 -1]
      so dp[i] = dp[i / 10] * dp[i % 10]
          = dp[(i - 1) / 10] * dp[i % 10]
          = dp[i - 1] / dp[(i - 1) % 10] * dp[i % 10]
          = dp[i - 1] * dp[i % 10] / dp[i % 10 -1]

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Why is c and D soo hard

Good and interesting problems, definitely learned something through the contest

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Can someone please explain why this code for G is giving TLE at test case 25. I am following a bit different approach to encounter bulbs in cycle but it is O(N) only. This is my submission link -> https://codeforces.com/contest/1907/submission/236036536

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Div.3 at its best! :)

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Can someone explain F,i don't understand tutorial at all.

  • »
    »
    5 месяцев назад, # ^ |
    Rev. 2   Проголосовать: нравится +20 Проголосовать: не нравится

    You can think that:

    1. RR <=> 0(doing nothing)
    2. SRS <=> R

    So, we can conclude that:

    1. There will be no consecutive R
    2. It doesn't make sense to insert R in consecutive S

    The final structure must have a long string of S's in the middle, and an optional R at the beginning and end.

    • »
      »
      »
      5 месяцев назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      Thank you very much!

    • »
      »
      »
      5 месяцев назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      how does writing the array twice and then looking at the increasing and decreasing segments help ?

      • »
        »
        »
        »
        5 месяцев назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        Such array contains all shifts of initial one, if there is an increasing or decreasing segment of length $$$n$$$ it is one of the shifts we are searching for.

    • »
      »
      »
      5 месяцев назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      How can someone reach SRS===R condition?(How to think of this condition,intuition wise)

      • »
        »
        »
        »
        5 месяцев назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        Consider RSR, you move the first element of array to the last place, and shift all other elements to the left, it's a reversed operation to S, so S(RSR) will not change the array, therefore SRS === R:)

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

did anyone got rating for this contest

»
5 месяцев назад, # |
  Проголосовать: нравится +2 Проголосовать: не нравится

In C, how do you prove that if no character appears more than floor(n/2) times, we can always achieve n%2 length of the final string? Please help.

»
5 месяцев назад, # |
  Проголосовать: нравится +8 Проголосовать: не нравится

коротко и ясно

»
5 месяцев назад, # |
  Проголосовать: нравится +1 Проголосовать: не нравится

Nearly 24 hours have passed, and the rating still doesn't change?

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Is the reason why editorial's check function for Binary Search works trivial? Because after x steps, if the intersection with the segment is non empty => I have one sequence of steps that lands me after x steps inside that interval. It does not ensure that those steps are consistent with the last x-1 regions right? (It should since the editorial is right, but I don't see how we can prove it.)

  • »
    »
    5 месяцев назад, # ^ |
      Проголосовать: нравится +3 Проголосовать: не нравится

    Consider the segment after x steps, if you can find one with intersection. For all points inside this segment there is a point in the last segment you could have reached it from. In other words you can pick any point in the current valid segment, and there is a point in the last segment from where you could reach this. You can continue this reasoning to the first segment. I agree, this is not that trivial to see.

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

tql

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

My back traversal solution for Problem B:

Solution
»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

in problem C, if max. freq is greater than or equal to half then the answer would be 2*max freq — total letters but if it is less than that ? would it always get paired up if its not odd. Please explain it in detail . I am not getting the intuition

  • »
    »
    5 месяцев назад, # ^ |
    Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

    This isn't a mathematical proof but more of an intuitive one: If you have an odd length of string with different characters, you can remove all but one of them. i.e: abcfdeg -> ... -> c

    Notice you can always pair the character with the max frequency with any other character. This is intuitive enough, but here is more (informal) intuitive reasoning in case you're not convinced:

    Assume it is not the case, it would imply the entire string has same characters (trivial), or that the max frequency character needs to be paired with some specific character for deletion which would violate the definition in the problem.

    As for the reasoning behind why it is 2*maxfreq — n, consider the following case: "xxxxxxxxxyyyyyxxyy" Note that y can be any character that is not x. We keep on deleting "xy" until a string of x is left.

    number of x in the end = freq[x] — freq[y]

    freq[y] = n — freq[x]

    Substitute that in and you will get

    number of x in the end = freq[x] — (n — freq[x])

    = 2*freq[x] — n.

    In the case where the length is odd in which case we cannot delete one character. try "abc" or "xabcd". Also since we are pairing characters we can pair at most floor(n/2) characters.

    • »
      »
      »
      5 месяцев назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      Yes this I understood but suppose I have the string "aaaaabbccccddd", won't there be 2 d remaining after I paired all a with b and c. The order thing I'm not getting that how will the letters be paired .

      • »
        »
        »
        »
        5 месяцев назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        You can pair other letters as well. The key observation is that only the majority character will remain in the end of all moves. (only if it occurs more than n/2 times.) Consider the following sequence of operations.

        aaaaab bc cccddd

        aaaaa bc ccddd

        aaaa ac cddd

        aaa ac ddd

        aa ad dd

        a ad d

        ad

        .

»
5 месяцев назад, # |
  Проголосовать: нравится +13 Проголосовать: не нравится

Thank you for such a wonderful round pashka, Vladosiya, MikeMirzayanov. I will be looking forward to a new and interesting round from you.

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

G is very similar to https://codeforces.com/problemset/problem/1872/F. Just a little addition that the nodes now have states attached to them.

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Hi, can anyone tell me why this is TLE in Python but AC in C++?

Python: 236125120 it is TLE without the fastIO line as well.

C++: 236125273

I am having an identity crisis

»
5 месяцев назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

Hi, can anyone tell me why this is TLE in Python but AC in C++?

Python: 236125120 it is TLE without the fastIO line as well.

C++: 236125273

I am having an identity crisis.

*accidentally posted the comment in Russian, my apologies for the spam

  • »
    »
    5 месяцев назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    Because string concatenation via + is very expensive operation in Python. Here is you code but string and s += are replaced with array and s.append(). It passes. 236138895

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

can somebody explain what this line of code means in the solution of F: minn = min(minn, i-n+1, len(p)-i+1)

»
5 месяцев назад, # |
  Проголосовать: нравится +14 Проголосовать: не нравится

Is this Tutorial written for those who don't need it?

No proof, No explanation, Only conclusion. Oh, yes, I completely understood

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Is the following true?


If in a group of numbers, the frequency of each number is less than the total count of numbers in the group, then if we were to eliminate the numbers, 1 pair of unequal numbers at a time, then either 0 or 1 numbers will remain at the end?
»
5 месяцев назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

Is the following true?


For a group of numbers, of size n, if the freq of each number is less than n/2 and if you were to eliminate 1 pair of unequal numbers at a time, you will be left 0 or 1 numbers.
»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

236178810 Can Anyone tell me what is wrong in the mentioned code.

»
5 месяцев назад, # |
Rev. 2   Проголосовать: нравится +16 Проголосовать: не нравится

The problems are great, but I feel that the editorial is written rather poorly.

Here is a (hopefully) more intuitive editorial of problem F -

Let us consider the inverse of the operations given in the original problem, for the sake of better understanding.
Given a sorted array in non-decreasing order $$$s$$$, you can perform two operations:
- Shift Inverse: move the first element of the array to the last place, and shift all other elements to the left, so you get the array $$$s_2,s_3,...,s_n,s_1$$$.
- Reverse: reverse the whole array, so you get the array $$$s_n,s_{n-1},...,s_1$$$.

By observation, we realize, that there are three types of arrays that arise when we perform the above operations on some sorted array $$$s$$$:
i) The most basic of it is the reverse of $$$s$$$ — the array $$$s_n,s_{n-1},...,s_1$$$.
ii) An array of the form $$$s_k,s_{k+1},...,s_n,s_1,s_2,...,s_{k-1}$$$, $$$1<k \le n$$$.
iii) An array of the form $$$s_k,s_{k-1},...,s_1,s_n,s_{n-1},...,s_{k+1}$$$, $$$1 \le k<n$$$.

Thus, we can break down the original problem into the following cases:

  1. If $$$a$$$ is sorted — No moves required, answer is $$$0$$$.

  2. If $$$a$$$ is sorted in reverse order — reversing the array solves it, answer is $$$1$$$.

  3. If $$$a$$$ is of the form presented in case ii) above —
    Let us break the array into two parts: the first part being the part of $$$a$$$ corresponding to $$$s_k,s_{k+1},...,s_n$$$ (let us call this part $$$F$$$) and the second part being the part of $$$a$$$ corresponding to $$$s_1,s_2,...,s_{k-1}$$$ (let us call this part $$$S$$$). We can solve this in two ways —
    (a) perform the 'Shift' operation on all elements of $$$S$$$. So total number of moves = $$$|S|$$$.
    (b) perform the 'Reverse' operation on $$$a$$$, perform 'Shift' operation on all elements of $$$F$$$, and then perform the 'Reverse' operation again. So total number of moves = $$$|F|+2$$$.
    We take the minimum of (a) and (b), and that is our answer.

  4. If $$$a$$$ is of the form presented in case iii) above —
    Let us break the array into two parts: the first part being the part of $$$a$$$ corresponding to $$$s_k,s_{k-1},...,s_1$$$ (let us call this part $$$F$$$) and the second part being the part of $$$a$$$ corresponding to $$$s_n,s_{n-1},...,s_{k+1}$$$ (let us call this part $$$S$$$). We can solve this in two ways —
    (a) perform the 'Shift' operation on all elements of $$$S$$$, and then perform the 'Reverse' operation. So total number of moves = $$$|S|+1$$$.
    (b) perform the 'Reverse' operation on $$$a$$$ and then perform 'Shift' operation on all elements of $$$F$$$. So total number of moves = $$$|F|+1$$$.
    We take the minimum of (a) and (b), and that is our answer.

  5. If $$$a$$$ is neither of the cases presented above, then the answer is $$$-1$$$.

C++ code for reference.

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

[DOUBT][PROBLEM G] — > can someone explain how to find minimum number of operations to turn off all turned on lights in the cycle? firstly, we will remove/turn off all nodes with in-degree=0 and will keep on removing till we find the cycle. I am struck after this point.

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

[DOUBT][PROBLEM G] — > can someone explain how to find minimum number of operations to turn off all turned on lights in the cycle? firstly, we will remove/turn off all nodes with in-degree=0 and will keep on removing till we find the cycle. I am struck after this point.

  • »
    »
    5 месяцев назад, # ^ |
      Проголосовать: нравится +2 Проголосовать: не нравится

    Find any light that is on in the cycle. There are only two ways for it too be turned off — either you directly flip it's switch or you flip the switch of the previous node in the cycle. Once you've chosen the starting node to start flipping you can move through the greedily flipping any lights that are on. Calculate the number of flips for both starting nodes and choose the smaller.

»
5 месяцев назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

For F, we can also notice that the problem is essentially asking for the minimum number of steps to move the last decrement (or increment but flip it to become a decrement if num decrements <= 1) to the last position such that a[n-1] - a[0] > 0 and none of the other pairs are decreasing. To do this, we can analyze the various cases:

  1. Num decrements from [0, 1] to [n-2, n-1] is 0: No operations are required so output 0.
  2. Num increments from [0, 1] to [n-2, n-1] is 0: Only 1 reverse operation is required so output 1.
  3. Num decrements from [0, 1] to [n-1, 0] > 1 and num increments from [0, 1] to [n-1, 0] > 1:
    It is not possible to shift and reverse the array into a non-decreasing order as shift preserves both num increments and num decrements while reverse swaps decrements with increments so number of decrements can never be 0 or 1.
  4. Num increments > num decrements (i.e. 1):
    We need to shift the decrement to be at pos [n-1, 0]. Suppose the decrement is at pos [i, (i+1) % n]. Then this can be done in min(n-1-i, 3+i) moves as if it is closer to the front, we reverse the array twice to minimize the number of moves.
  5. Num decrements > num increments (i.e. 1):
    We need to reverse the increment to become a decrement and shift the decrement to be at pos [n-1, 0] (in any order). Suppose the increment is at pos [i, (i+1) % n]. Then this can be done in min(n-i, 2+i) moves as if it is closer to the front, we reverse the array first to minimize the number of moves.
  6. Num increments == num decrements == 1 and last increment pos i [i, (i+1) % n] > last decrement pos j [j, (j+1) % n]:
    We can choose to either shift the increment to [n-1, 0] and reverse the array or reverse the array and shift the decrement (now increment) to [n-1, 0] and reverse the array again. This will use min(n-i, 3+j) moves.
  7. Num increments == num decrements == 1 and last increment pos i [i, (i+1) % n] < last decrement pos j [j, (j+1) % n]:
    We can choose to either shift the decrement to [n-1, 0] or reverse the array and shift the increment (now decrement) to [n-1, 0]. This will use min(n-1-j, 2+i) moves.
»
5 месяцев назад, # |
  Проголосовать: нравится +2 Проголосовать: не нравится

The editorials are very hard to understand, specially for E, F and G. :)

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

I solved problem B using the alternate approach (i.e., given in editorial deleting from reverese of array) but i got TLE can anyone help me out whats wrong with it. my solution

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Please, upvote this comment

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

can someone give a real proof to the claim in E, that the condition is satisfied only in the case when there is no carry over in addition, and thus never in the case there is a carry over? If not proof, a sound intuitive explanation will also help.

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In Problem E. 1907E — Good Triples Can someone please tell the proof for:

"A triplet is considered good only if each digit of the number n was obtained without carrying over during addition."

This is a good observation, but how can I prove such information or approach it at least?

»
5 месяцев назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

There exists a hashing solution to problem F.

You can save two hash values , one for the sorted non-decreasing array and the other for the sorted non-increasing array.

Then, you can try doing the operations on the original array or on the reverse of it ( with additional cost of one operation). Doing the operation on an element which is the last in array is simply subtracting the element from the current hash, dividing by base and adding this value * base ^ (n-1).

Then, the first moment where the hashes are equal , we have found an answer to minimize over it and stop doing operations.

Link to submission: https://codeforces.com/contest/1907/submission/236598692.

P.S I found this solution more understandable than what is written in the tutorial.

  • »
    »
    4 месяца назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    But hashing ( although the probability is very small) may lead you to collisions in the worst case..

»
5 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

For problem C, why is it true that we can remove all possible pairs regardless of the order of deletions if no character occurs in the string more than n/2 times? For example, in the string aabbcc it does matter the order of deletion, because if we just deleted ab and ab we would be left with cc which is not optimal.

»
4 месяца назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

can someone explain problem D

»
3 месяца назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

wo bu neng li jie ni xie zhe ge ti jie shi gei wo zhe zhong cai ji kan de dong de ma?!

»
3 месяца назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

There’s my view of the solution of problem E (in understandable English). https://youtu.be/VKqPUNGcD0k

»
7 недель назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

I have got a very easy solution for problem E i.e for which digit of input number, you have certain combinations available. so, its better to mulitply those combinations for each of the digits of input number. Also, you can pre-compute the combinations for each digit(0-9) by simply observing the test case.